1. Environment Installation (Based on alignment-handbook)

conda create -n handbook python=3.10 && conda activate handbook
python -m pip install .
pip install vllm

2. Doing SFT training to obtain a Reference teacher and initialize the student model.(take 1.8b student as an example).

CUDA_VISIBLE_DEVICES=${GPU_IDS} \
ACCELERATE_LOG_LEVEL=info \
DS_SKIP_CUDA_CHECK=1 \
accelerate launch \
  ${DIR}/scripts/run_sft.py \
  ${DIR}/exp_recipes/h2o-danube2-1.8b-dpomix7k/initial_student.yaml


CUDA_VISIBLE_DEVICES=${GPU_IDS} \
ACCELERATE_LOG_LEVEL=info \
DS_SKIP_CUDA_CHECK=1 \
accelerate launch \
  ${DIR}/scripts/run_sft.py \
  ${DIR}/exp_recipes/h2o-danube2-1.8b-dpomix7k/run_sft_teacher.yaml

3. Doing DPO training on Reference Teacher to get a DPO teacher.

CUDA_VISIBLE_DEVICES=${GPU_IDS} \
ACCELERATE_LOG_LEVEL=info \
DS_SKIP_CUDA_CHECK=1 \
accelerate launch \
  ${DIR}/scripts/run_dpo.py \
  ${DIR}/exp_recipes/h2o-danube2-1.8b-dpomix7k/teacher-dpo.yaml

4. Let DPO student generate the y_hat to obtain the <teacher, student> pairs. (Please modify the teacher_path and student path to your trained DPO teacher and initialized student)

  python precompute_logits_recipes/h2o-1.8b-deita-dpomix/get_output_from_teacher_student.py
  python precompute_logits_recipes/h2o-1.8b-deita-dpomix/get_output_from_teacher_student.py
  python precompute_logits_recipes/h2o-1.8b-deita-dpomix/get_output_from_teacher_student.py

5. Let DPO teacher, Reference Teacher, Initial Student do inference on preference dataset and <teacher, student> pair dataset.

CUDA_VISIBLE_DEVICES=0 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml &

CUDA_VISIBLE_DEVICES=1 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml &

CUDA_VISIBLE_DEVICES=2 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml &

CUDA_VISIBLE_DEVICES=3 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml &

CUDA_VISIBLE_DEVICES=4 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml &

CUDA_VISIBLE_DEVICES=5 WANDB_DISABLED=true python \
  custom_script/run_dpo_custom.py \
  precompute_logits_recipes/h2o-1.8b-deita-dpomix/precompute_reference_dpo.yaml

6. keep the <chosen-rejected> pair for CDKD training, and the <chosen-student> pair for ADPA training.
  python precompute_logits_recipes/h2o-1.8b-deita-dpomix/merge_output_chosen_student_stage1.py &
  python precompute_logits_recipes/h2o-1.8b-deita-dpomix/merge_raw_chosen_rejected_stage1.py

7. Do CDKD training and the ADPA training:

CUDA_VISIBLE_DEVICES=0,1,2,3,4,5,6,7 ACCELERATE_LOG_LEVEL=info DS_SKIP_CUDA_CHECK=1 \
accelerate launch \
  --main_process_port 23422 \
  custom_script/run_distill_dpo.py \
  exp_recipes/h2o-danube2-1.8b-dpomix7k/DCKD.yaml
  
CUDA_VISIBLE_DEVICES=0,1,2,3,4,5,6,7 ACCELERATE_LOG_LEVEL=info DS_SKIP_CUDA_CHECK=1 \
accelerate launch \
  --main_process_port 23422 \
  custom_script/run_distill_dpo.py \
  exp_recipes/h2o-danube2-1.8b-dpomix7k/DCKD.yaml

9. For ADPA+ Training, collect the output from DCKD student
